"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var expression_utils_1 = require("./../expression-utils");
var chai_1 = require("chai");
var _expressionUtils = new expression_utils_1.ExpressionUtils();
var ExpressionUsage = /** @class */ (function () {
    function ExpressionUsage(instance) {
        this.instance = instance;
    }
    ExpressionUsage.prototype.equals = function (expression, value) {
        var result = _expressionUtils.getValueByExpression(this.instance, expression) === value;
        return result;
    };
    ExpressionUsage.prototype.equalsE = function (expression1, expression2) {
        var result = _expressionUtils.getValueByExpression(this.instance, expression1)
            === _expressionUtils.getValueByExpression(this.instance, expression2);
        return result;
    };
    return ExpressionUsage;
}());
exports.ExpressionUsage = ExpressionUsage;
describe("Return Expression method", function () {
    var instance = {
        id: 1,
        name: "Test",
        description: "Descrição",
        date: new Date(),
        isValid: true,
        reference: {
            id: 2,
            name: "Reference"
        }
    };
    var expression = new ExpressionUsage(instance);
    it("should return id == 0", function () {
        var result = expression.equals(function (x) { return x.id; }, 0);
        chai_1.expect(result).to.equal(false);
    });
    it("should return column with column", function () {
        var result = expression.equalsE(function (x) { return x.id; }, function (x) { return x.reference.id; });
        chai_1.expect(result).to.equal(false);
    });
    it("lambda column vs variable", function () {
        var v = 1;
        var result = expression.equals(function (x) { return x.id; }, v);
        chai_1.expect(result).to.equal(true);
    });
});
